# coding: utf-8

"""
    Form Service API

    A list of form and Xaas APIs.  This page describes the RESTful APIs for Form Service. The APIs facilitate CRUD operations on the various resources and entities used throughout Form service (Custom Resource , Form Definition etc.) and allow operations on them (creating custom resource type , fetch form status etc.).  Some of the APIs that list collections of resources also support OData like implementation. Below query params can be used across Form and XaaS entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/form-service/api/custom/resource-types?$orderby=name%20DESC```  2. `page`, `size` - page used in conjunction with `size` helps in pagination of resources.      ```/form-service/api/custom/resource-types?page=0&size=20```   # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class SchemagenerationFormBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'description': 'str',
        'project_id': 'str',
        'type': 'str',
        'input_parameters': 'list[FormserviceapiformsdesignerrunnableitemelementsInputParameters]',
        'output_parameters': 'list[FormserviceapiformsdesignerrunnableitemelementsInputParameters]',
        'endpoint_link': 'str',
        'input_bindings': 'list[FormserviceapiformsdesignerrunnableitemelementsInputBindings]'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'description': 'description',
        'project_id': 'projectId',
        'type': 'type',
        'input_parameters': 'inputParameters',
        'output_parameters': 'outputParameters',
        'endpoint_link': 'endpointLink',
        'input_bindings': 'inputBindings'
    }

    def __init__(self, id=None, name=None, description=None, project_id=None, type=None, input_parameters=None, output_parameters=None, endpoint_link=None, input_bindings=None):  # noqa: E501
        """SchemagenerationFormBody - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._description = None
        self._project_id = None
        self._type = None
        self._input_parameters = None
        self._output_parameters = None
        self._endpoint_link = None
        self._input_bindings = None
        self.discriminator = None
        self.id = id
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if project_id is not None:
            self.project_id = project_id
        self.type = type
        if input_parameters is not None:
            self.input_parameters = input_parameters
        if output_parameters is not None:
            self.output_parameters = output_parameters
        if endpoint_link is not None:
            self.endpoint_link = endpoint_link
        if input_bindings is not None:
            self.input_bindings = input_bindings

    @property
    def id(self):
        """Gets the id of this SchemagenerationFormBody.  # noqa: E501


        :return: The id of this SchemagenerationFormBody.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this SchemagenerationFormBody.


        :param id: The id of this SchemagenerationFormBody.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this SchemagenerationFormBody.  # noqa: E501


        :return: The name of this SchemagenerationFormBody.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this SchemagenerationFormBody.


        :param name: The name of this SchemagenerationFormBody.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this SchemagenerationFormBody.  # noqa: E501


        :return: The description of this SchemagenerationFormBody.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this SchemagenerationFormBody.


        :param description: The description of this SchemagenerationFormBody.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def project_id(self):
        """Gets the project_id of this SchemagenerationFormBody.  # noqa: E501


        :return: The project_id of this SchemagenerationFormBody.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this SchemagenerationFormBody.


        :param project_id: The project_id of this SchemagenerationFormBody.  # noqa: E501
        :type: str
        """

        self._project_id = project_id

    @property
    def type(self):
        """Gets the type of this SchemagenerationFormBody.  # noqa: E501


        :return: The type of this SchemagenerationFormBody.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this SchemagenerationFormBody.


        :param type: The type of this SchemagenerationFormBody.  # noqa: E501
        :type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    @property
    def input_parameters(self):
        """Gets the input_parameters of this SchemagenerationFormBody.  # noqa: E501


        :return: The input_parameters of this SchemagenerationFormBody.  # noqa: E501
        :rtype: list[FormserviceapiformsdesignerrunnableitemelementsInputParameters]
        """
        return self._input_parameters

    @input_parameters.setter
    def input_parameters(self, input_parameters):
        """Sets the input_parameters of this SchemagenerationFormBody.


        :param input_parameters: The input_parameters of this SchemagenerationFormBody.  # noqa: E501
        :type: list[FormserviceapiformsdesignerrunnableitemelementsInputParameters]
        """

        self._input_parameters = input_parameters

    @property
    def output_parameters(self):
        """Gets the output_parameters of this SchemagenerationFormBody.  # noqa: E501


        :return: The output_parameters of this SchemagenerationFormBody.  # noqa: E501
        :rtype: list[FormserviceapiformsdesignerrunnableitemelementsInputParameters]
        """
        return self._output_parameters

    @output_parameters.setter
    def output_parameters(self, output_parameters):
        """Sets the output_parameters of this SchemagenerationFormBody.


        :param output_parameters: The output_parameters of this SchemagenerationFormBody.  # noqa: E501
        :type: list[FormserviceapiformsdesignerrunnableitemelementsInputParameters]
        """

        self._output_parameters = output_parameters

    @property
    def endpoint_link(self):
        """Gets the endpoint_link of this SchemagenerationFormBody.  # noqa: E501


        :return: The endpoint_link of this SchemagenerationFormBody.  # noqa: E501
        :rtype: str
        """
        return self._endpoint_link

    @endpoint_link.setter
    def endpoint_link(self, endpoint_link):
        """Sets the endpoint_link of this SchemagenerationFormBody.


        :param endpoint_link: The endpoint_link of this SchemagenerationFormBody.  # noqa: E501
        :type: str
        """

        self._endpoint_link = endpoint_link

    @property
    def input_bindings(self):
        """Gets the input_bindings of this SchemagenerationFormBody.  # noqa: E501


        :return: The input_bindings of this SchemagenerationFormBody.  # noqa: E501
        :rtype: list[FormserviceapiformsdesignerrunnableitemelementsInputBindings]
        """
        return self._input_bindings

    @input_bindings.setter
    def input_bindings(self, input_bindings):
        """Sets the input_bindings of this SchemagenerationFormBody.


        :param input_bindings: The input_bindings of this SchemagenerationFormBody.  # noqa: E501
        :type: list[FormserviceapiformsdesignerrunnableitemelementsInputBindings]
        """

        self._input_bindings = input_bindings

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SchemagenerationFormBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SchemagenerationFormBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
